
import java.util.*;
import java.awt.*;
import java.awt.geom.Point2D;



class Canette extends Obstacle
{
	private Point centre;
	private Point gauche;
	private Point droit;
	private int rayon;


	Canette(Point centre, int rayon)
	{
	super();
	gauche = new Point((int) (centre.getX() - rayon), (int) centre.getY());
	droit = new Point((int) (centre.getX() + rayon), (int) centre.getY());
	this.centre = centre;
	this.rayon = rayon;
	}


	public /*@ pure */ Vector getReferences()
	{
	Vector v;

	v = new Vector();
	v.add(new ObstacleReference(gauche, this));
	v.add(new ObstacleReference(droit, this));

	return v;
	}


	/* retourne les points dfinissant l'objet */
	public /*@ pure */ Vector getPoints()
	{
	Vector v;

	v = new Vector();
	v.add(gauche);
	v.add(droit);

	return v;
	}


	public /*@ pure */ Point getGauche()
	{
	return gauche;
	}


	public /*@ pure */ Point getDroit()
	{
	return droit;
	}


	public /*@ pure */ Point getCentre()
	{
	return centre;
	}


	public /*@ pure */ int getRayon()
	{
	return rayon;
	}


	public boolean intersection(Point p)
	{
	if ((p.getX() >= this.getGauche().getX()) && (p.getX() <= this.getDroit().getX()))
		return true;
	return false;
	}


	public /*@ pure */ boolean chevauche(Obstacle o)
	{
	if (o instanceof Cadre)
		{
		Cadre c = (Cadre) o;
		return(this.getCentre().getX() - rayon <= 0 || this.getCentre().getX() + rayon >= c.getLongueur() ||
				this.getCentre().getY() - rayon <= 0 || this.getCentre().getY() + rayon >= c.getHauteur());
		}	
	else
		{
		Canette c = (Canette) o;
		return(centre.distance((Point2D) c.getCentre()) <= rayon + c.getRayon());
	 	}
 	}


	public String toString()
	{
	return ("canette");
	}


	public String longToString()
	{
	return ("canette " + rayon + " pg : " + gauche.getX() + "," + gauche.getY());
	}
}

